package edu.columbia.sip;

import java.net.UnknownHostException;
import java.io.IOException;

public class RemoteAvailabilityListener implements AvailabilityListener {
    /** The request which generated the creation of this listener */
    SIPRequest _request;

    public RemoteAvailabilityListener(SIPRequest request) {
    //    Debug.println("RemoteAvailabilityListener constructed for request '" + request.getHeaders() "'");
        _request = request;
    }

    public void here(AvailabilityEvent ae) throws SIPException {
        System.out.println("RemoteAvailabilityListener.here() called.");
        SIPResponse resp = new SIPResponse(_request, 200, "User is now available.");
        try {
            SIPConnection conn = new SIPConnection(_request.getResponseAddress(),
                                                   _request.getResponsePort());
            conn.putMessage(resp);
            conn.close();
        } catch (UnknownHostException uhe) {
            System.out.println("RemoteAvailabilityListener.here(): Error sending response.\n" + uhe);
        } catch (IOException ioe) {
            System.out.println("RemoteAvailabilityListener.here(): Error sending response.\n" + ioe);
        }
    }

    public void gone(AvailabilityEvent ae) {
        SIPResponse resp = new SIPResponse(_request, 200, "User is no longer available.");
        try {
            SIPConnection conn = new SIPConnection(_request.getResponseAddress(),
                                                   _request.getResponsePort());
            conn.putMessage(resp);
        } catch (UnknownHostException uhe) {
            System.out.println("RemoteAvailabilityListener.here(): Error sending response.\n" + uhe);
        } catch (IOException ioe) {
            System.out.println("RemoteAvailabilityListener.here(): Error sending response.\n" + ioe);
        }
    }

    public void unknown(AvailabilityEvent ae) {
    }

    /** the URL of the person you want availability information for. */
    public SIPURL getURL() {
//        String loc = _request.getHeader(SIPToken.LOCATION);
//        return new SIPURL(loc.substring(loc.indexOf(':') + 1, loc.indexOf(';')));
        return _request.getURL();
    }
}
